

public class Token implements Tokens {
	public int tipo;
	public String texto;
	public int lin;

	public final static int EOF        = 0;
		
	public final static String[] nomes = new String[] {
		"<<EOF>>", "and", ":=", "begin", "bool", "elif",
		"else", "end", "false", "id", "if", "int", "neg",
		"not", "num", "or", "pass", "read", "true", "void",
		"while", "write"
	};
	
	public Token(int tipo, String texto, int lin) {
		this.tipo = tipo;
		this.texto = texto;
		this.lin = lin + 1;
	}

	public Token(int tipo, int lin) {
		this.tipo = tipo;
		this.texto = tipo < nomes.length ? nomes[tipo] :
			Character.toString((char)tipo);
		this.lin = lin + 1;
	}

	@Override
	public boolean equals(Object other) {
		Token tok = (Token)other;
		return tipo == tok.tipo;
	}
	
	@Override
	public int hashCode() {
		return tipo;
	}

	@Override
	public String toString() {
		String tok = "," + lin + ")";
		if(tipo < nomes.length && !texto.equals(nomes[tipo]))
			return "(" + nomes[tipo] + "," + texto + tok;
		else
			return "(" + texto + tok;
	}
}
